/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'cpu.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.cpu;

import ru.ispras.microtesk.model.api.ProcessorModel;
import ru.ispras.microtesk.model.api.metadata.MetaModelPrinter;
import ru.ispras.microtesk.model.api.state.ModelStatePrinter;
import ru.ispras.microtesk.model.api.instruction.IAddressingMode;
import ru.ispras.microtesk.model.api.instruction.IOperation;
import ru.ispras.microtesk.model.cpu.mode.*;
import ru.ispras.microtesk.model.cpu.op.*;

import static ru.ispras.microtesk.model.cpu.shared.Shared.*;

public final class Model extends ProcessorModel {
  public static final String NAME = "cpu";

  private static final IAddressingMode.IInfo[] __MODES = new IAddressingMode.IInfo[] {
    IMM.INFO,
    REG.INFO,
    MEM.INFO
  };

  private static final IAddressingMode.IInfo[] __MODE_GROUPS = new IAddressingMode.IInfo[] {
    OPRNDL.INFO,
    OPRNDR.INFO
  };

  private static final IOperation.IInfo[] __OPS = new IOperation.IInfo[] {
    ADD.INFO,
    SUB.INFO,
    MOV.INFO,
    alu_instr.INFO,
    J.INFO,
    JZ.INFO
  };

  private static final IOperation.IInfo[] __OP_GROUPS = new IOperation.IInfo[] {
    ALU.INFO,
    branch_instr.INFO,
    instruction.INFO
  };

  public Model() {
    super(
        NAME,
        __MODES,
        __MODE_GROUPS,
        __OPS,
        __OP_GROUPS,
        __REGISTERS,
        __MEMORY,
        __LABELS,
        __STATUSES,
        __RESETTER
        );
  }

  public static void printInformation() {
    final Model model = new Model();

    final MetaModelPrinter metaModelPrinter = new MetaModelPrinter(model.getMetaData());
    metaModelPrinter.printAll();

    final ModelStatePrinter modelStatePrinter = new ModelStatePrinter(model);
    modelStatePrinter.printRegisters();
  }

  public static void main(String[] args) {
    printInformation();
  }
}
 